;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@@@@@ @@@@  @@@   @@    @               @    @@   @@@  @@@@ @@@@@
;@@@@@ @@@@  @@@   @@    @    Aliases    @    @@   @@@  @@@@ @@@@@
;@@@@@ @@@@  @@@   @@    @               @    @@   @@@  @@@@ @@@@@
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

cprgmsw::init_prgm equ cprgmsw@0000
;****************************************
;*           No Input/Output            *
;* This function saves the exception    *
;* table and resets bit 2 of port 01,   *
;* thus allowing writes to lower memory *
;****************************************
;###################################################################

cprgmsw::deinit_prgm equ cprgmsw@0001
;****************************************
;*           No Input/Output            *
;* This function restores the exception *
;* table.                               *
;****************************************
;###################################################################

cprgmsw::init_getkey equ cprgmsw@0002
;****************************************
;* No Input/Output: Disables Auto-Int 1 *
;* This makes your program run faster   *
;* and makes getkey more reliable. You  *
;* can NOT call cprgmsw::getkey2 when   *
;* Auto-Int 1 is disabled.              *
;****************************************
;###################################################################

cprgmsw::deinit_getkey equ cprgmsw@0003
;****************************************
;* No Input/Output: Restores Auto-Int 1 *
;****************************************
;###################################################################

cprgmsw::getkey equ cprgmsw@0004
;****************************************
;* Input:                               *
;*   D0.L = Row of key to test          *
;*   D1.L = Column of key to test       *
;* Output:                              *
;*   D0.L = Non-Zero if key is down     *
;*                                      *
;* This function uses direct port       *
;* addressing to test if a certain key  *
;* is down. This kind of key testing    *
;* allows you to test for many keys     *
;* down at the same time, which is a    *
;* must in most games.                  *
;****************************************
;###################################################################

cprgmsw::getkey2 equ cprgmsw@0005
;*******************************************
;* No Input                                *
;* Output:                                 *
;*   D0.W = Key (like Basic getKey value)  *
;*                                         *
;* This function uses memory addresses     *
;* just like the TI Basic version of       *
;* getkey. The values this function can    *
;* return are in the TI-92+/89 manual.     *
;*******************************************
;###################################################################

cprgmsw::delay equ cprgmsw@0006
;****************************************
;* Input:                               *
;*   D0.L = Time to Delay               *
;* No Output                            *
;*                                      *
;* This function delays a small amount. *
;****************************************

cprgmsw::hex2str equ cprgmsw@0007
;****************************************
;* Input:                               *
;*   A0.L = Pointer to the buffer       *
;*   D0.L = Hex Number to convert       *
;*   D1.L = Number of Digits to convert *
;* Output:                              *
;*   A0.L = D0.L (as Hex) as a String   *
;****************************************

cprgmsw::pxltst equ cprgmsw@0008
;****************************************
;* Input:                               *
;*   D0.W = X Location                  *
;*   D1.W = Y Location                  *
;* Output:                              *
;*   D0.L = Pixel off:        0         *
;*          Pixel on:         1         *
;*          Invalid Location: 2         *
;****************************************

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@@@@@ @@@@  @@@   @@    @              @    @@   @@@  @@@@ @@@@@
;@@@@@ @@@@  @@@   @@    @    Macros    @    @@   @@@  @@@@ @@@@@
;@@@@@ @@@@  @@@   @@    @              @    @@   @@@  @@@@ @@@@@
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
init_getkey MACRO
	jsr cprgmsw::init_getkey
 ENDM
;###################################################################

deinit_getkey MACRO
	jsr cprgmsw::deinit_getkey
 ENDM
;###################################################################

;+------------------------------------------+
;|              getkey Macro                |
;| Arguments: Row, Column <of key to test>  |
;| Returns: D0 is NonZero if key is down    |
;| Special: BEQ after will branch on key    |
;|    down, BNE will brance if key is up    |
;+------------------------------------------+
getkey MACRO
	move.l d1,-(a7)
	move.l \1,d0
	move.l \2,d1
	jsr cprgmsw::getkey
	move.l (a7)+,d1
	cmp.l #1,d0
 ENDM
;###################################################################

;+------------------------------------+
;|               delay Macro          |
;| Arguments: Units of time to delay  |
;+------------------------------------+
delay MACRO	
	move.l d0,-(a7)
	move.l \1,d0
	jsr cprgmsw::delay
	move.l (a7)+,d0
 ENDM
;###################################################################

pusha MACRO
	movem.l d0-d7/a0-a6,-(a7)
 ENDM
;###################################################################

popa MACRO
	movem.l (a7)+,d0-d7/a0-a6
 ENDM
;###################################################################

cprgmsw::name MACRO
	dc.b 169," Prgm ",167,"w"
 ENDM


;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@@@@@ @@@@  @@@   @@    @                   @    @@   @@@  @@@@ @@@@@
;@@@@@ @@@@  @@@   @@    @    Information    @    @@   @@@  @@@@ @@@@@
;@@@@@ @@@@  @@@   @@    @                   @    @@   @@@  @@@@ @@@@@
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;
;                            TI 92+ Key Chart
;Row
; |      +-------+-------+-------+-------+-------+-------+-------+-------+
; V Col->|   7   |   6   |   5   |   4   |   3   |   2   |   1   |   0   |
;+-------+-------+-------+-------+-------+-------+-------+-------+-------+
;|   0   |  down | right |   up  |  left |  hand | shift |diamond|  2nd  |
;|   1   |   3   |   2   |   1   |   F8  |   W   |   S   |   Z   | unused|
;|   2   |   6   |   5   |   4   |   F3  |   E   |   D   |   X   | unused|
;|   3   |   9   |   8   |   7   |   F7  |   R   |   F   |   C   |  STO  |
;|   4   |   ,   |   )   |   (   |   F2  |   T   |   G   |   V   | space |
;|   5   |  TAN  |  COS  |  SIN  |   F6  |   Y   |   H   |   B   |   /   |
;|   6   |   P   | ENTER2|   LN  |   F1  |   U   |   J   |   N   |   ^   |
;|   7   |   *   |  APPS | CLEAR |   F5  |   I   |   K   |   M   |   =   |
;|   8   | unused|  ESC  |  MODE |   +   |   O   |   L   | theta |backspc|
;|   9   |  (-)  |   .   |   0   |   F4  |   Q   |   A   | ENTER1|   -   |
;+-------+-------+-------+-------+-------+-------+-------+-------+-------+
;       ENTER1 is on the alphabetic and numeric keypads
;       ENTER2 is next to the cursor pad
;       unused means no key is assigned to that combination