;******************************************include**************************************
	include "doorsos.h"
	include "cprgmsw.inc"
	include "MyInc.inc"
	include "graphlib.h"
	include "util.h"
	include "input.inc"
	include "Nibbelz.lvl"
	xdef _main
	xdef _ti92plus

;******************************************Defines**************************************

Max_Levels  equ 10 ; Changes this number to the number of levels in the Nibbelz.lvl file

;***************************************************************************************
;                                       Level code                                     *
;***************************************************************************************
;Discription: A special function, It takes care of which level to load                 *
;	      This funcion + the Max_Levels define is all you need to change for       *
;	      loading, adding and deleted new levels, it works like an if statement    *
;	      if level == 1 then load lvl1 vs:                                         *
;Switch_Level_Lbl1:                 ; lable for this if statement                      *
;	      cmp.w #1,Level        ; test if the level is = to 1                      *
;	      bne Switch_Level_Lbl2 ; jumps to the next label if not equal to          *
;	      lea Lvl1(pc),a0       ; lvl1 as the varible for the level to load        *
;                                   ; you can changes this varible to any varible level*
;                                                                                      *
;Note: Only change the code between the @@@@@ for editing which levels to load         *
;***************************************************************************************

Which_Level:

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

Switch_Level_Lbl1:
	cmp.w #1,Level
	bne Switch_Level_Lbl2
	lea Lvl1(pc),a0
Switch_Level_Lbl2:
	cmp.w #2,Level
	bne Switch_Level_Lbl3
	lea Lvl2(pc),a0
Switch_Level_Lbl3:
	cmp.w #3,Level
	bne Switch_Level_Lbl4
	lea Lvl3(pc),a0
Switch_Level_Lbl4:
	cmp.w #4,Level
	bne Switch_Level_Lbl5
	lea Lvl4(pc),a0
Switch_Level_Lbl5:
	cmp.w #5,Level
	bne Switch_Level_Lbl6
	lea Lvl5(pc),a0
Switch_Level_Lbl6:
	cmp.w #6,Level
	bne Switch_Level_Lbl7
	lea Lvl6(pc),a0
Switch_Level_Lbl7:
	cmp.w #7,Level
	bne Switch_Level_Lbl8
	lea Lvl7(pc),a0
Switch_Level_Lbl8:
	cmp.w #8,Level
	bne Switch_Level_Lbl9
	lea Lvl8(pc),a0
Switch_Level_Lbl9:
	cmp.w #9,Level
	bne Switch_Level_Lbl10
	lea Lvl9(pc),a0
Switch_Level_Lbl10:
	cmp.w #10,Level
	bne Switch_Level_Lbl11
	lea Lvl10(pc),a0
Switch_Level_Lbl11:

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

	rts

;******************************************Macros***************************************
;Discription: puts a line on the screen
;Input: Lines x1,y1,x2,y2
;Output: None

Lines MACRO
	pusha
	clr.l d3
	clr.l d2
	clr.l d1
	clr.l d0
	move.b \1,d0
	move.b \2,d1
	move.b \3,d2
	move.b \4,d3
	lea  LCD_MEM,a0
	jsr graphlib::line
	popa
	ENDM

;******************************************
;Discription: Puts a 4 by 4 block on the screen
;Input: putblock x1,y1
;Output: None

putblock Macro
	pusha
	move.l \1,-(a7)
	move.l \2,-(a7)
	move.l (a7)+,d1
	move.l (a7)+,d0
	bsr putblock_code	
	popa
	ENDM

putblock_code:
	move.b d0,d4
	move.b d1,d5
	move.b d4,d6
	move.b d5,d7

	add.b #3,d6
	Lines d4,d5,d6,d5
	add.b #1,d5
	Lines d4,d5,d6,d5
	add.b #1,d5
	Lines d4,d5,d6,d5
	add.b #1,d5
	Lines d4,d5,d6,d5
	rts 
;*****************************************Functions*************************************
;Discription: Changes the length of the snake
;Input: d0
;Output: None

ChangLen:
	move.b d0,d1
	move.b Snake_Lenght,d0
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
	cmp.b  d1,d0
	bge endmacro
	cmp.b  #250,d1
	blt endmacro
	move.b d0,d2
	clr.l d0
	move.b d2,d0
	add.b #1,d0
	add.l d0,a0
	add.l d0,a1
	move.b d1,d2
	sub.b d0,d2
	move.b d2,d0
ChangLenLoop1
	
	sub.l #1,a0
	move.b (a0),d2
	add.l #1,a0
	move.b d2,(a0)+
	
	sub.l #1,a1
	move.b (a1),d2
	add.l #1,a1
	move.b d2,(a1)+
	
	dbra.b d0,ChangLenLoop1
	move.b d1,Snake_Lenght
endmacro:
	rts

;******************************************
;Discription: Puts the apple
;Input: None
;Output: None

Apples:
Apples_Loop:
	clr.l d0
	clr.l d1
	move.b #58,d0
	jsr util::random ; get x
	mulu.b #4,d0
	add.b #4,d0
	move.b d0,apple_x
	
	move.b #28,d0 
	jsr util::random ; get y
	mulu.b #4,d0
	add.b #4,d0
	move.b d0,apple_y
	
	clr.l d0
	clr.l d1
	move.b apple_x,d0
	move.b apple_y,d1
	move.l #AppleSprite,a0
	jsr graphlib::put_sprite
	
	clr.l d0 ; test apple
	clr.l d1	
	move.b apple_x(pc),d0
	move.b apple_y(pc),d1
	add.b #3,d0
	add.b #3,d1
	jsr cprgmsw::pxltst
	cmp.l #1,d0
	bne Apples_Loop
End_Apples:
	rts
	
;******************************************
;Discription: Puts the snake on the screen when level begins
;Input: None
;Output: None

Snake:  
	pusha
	clr.l d0
	move.b Snake_Lenght,d0
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
SnakeLoop1:
	move.b (a0),d1
	move.b (a1),d2
	lea 1(a0),a0
	lea 1(a1),a1
 	mulu.b #4,d1
	mulu.b #4,d2
	putblock d1,d2
	dbra.b d0,SnakeLoop1
	popa
	rts

;******************************************
;Discription: Moves the snake around the screen
;Input: None
;Output: None

movesnake:
	clr.l d0
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
	move.b Snake_Lenght(pc),d0
	add.l d0,a0
	add.l d0,a1

movesnakeloop1:
 	move.b (a0),1(a0)
	sub.l #1,a0
	move.b (a1),1(a1)
	sub.l #1,a1
	dbra d0,movesnakeloop1

	clr.l d0
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
	move.b Direction,d0

	cmp #1,d0
	bne movesnakelbl1
	move.b (a0),d1
	sub.b #1,d1
	move.b d1,(a0)
movesnakelbl1:
	cmp #2,d0
	bne movesnakelbl2
	move.b (a0),d1
	add.b #1,d1
	move.b d1,(a0)
movesnakelbl2:
	cmp #3,d0
	bne movesnakelbl3
	move.b (a1),d1
	sub.b #1,d1
	move.b d1,(a1)
movesnakelbl3:
	cmp #4,d0
	bne movesnakelbl4
	move.b (a1),d1
	add.b #1,d1
	move.b d1,(a1)
movesnakelbl4:

	bsr SnakeHit

	pusha
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
	clr.l d0
	move.b Snake_Lenght(pc),d0
	add.l d0,a0
	add.l d0,a1
	clr.l d0
	clr.l d1
	move.b (a0),d0
	move.b (a1),d1
	mulu.b #4,d0
	mulu.b #4,d1
	move.l #blank1,a0
	jsr graphlib::put_sprite
	popa

	rts

;******************************************
;Discription: Test if the snake hit something
;Input: None
;Output: None

SnakeHit:
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
	move.b Direction,d0
	cmp #5,d0
	beq SnakeHitLbl5
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
	clr.l d0
	clr.l d1
	move.b (a0),d0
	move.b (a1),d1
	mulu.w #4,d0
	mulu.w #4,d1
	add.w #1,d0
	add.w #1,d1
	jsr cprgmsw::pxltst
	cmp.l #1,d0
	beq SnakeHitLbl5
	move.b (a0),d0
	mulu.b #4,d0
	move.b (a1),d1
	mulu.b #4,d1 
	cmp.b apple_x,d0
	bne SnakeHitLbl6
	cmp.b apple_y,d1
	bne SnakeHitLbl6
	bsr Apples
	clr.l d0
	add.w #1,AppleNum
	move.b Snake_Lenght,d0
	add.w AppleNum,d0
	add.b #5,d0
	bsr ChangLen
	clr.l d0
	add.w #7,Score
	bsr Do_Bottom
	bra SnakeHitLbl5
SnakeHitLbl6:
	move.b #1,SnakeDied
SnakeHitLbl5:
	lea.l snake_x(PC),a0
	lea.l snake_y(PC),a1
	clr.l d0
	clr.l d1
	move.b (a0),d0
	move.b (a1),d1
	mulu.b #4,d0
	mulu.b #4,d1
	putblock d0,d1
	rts

;******************************************
;Discription: inverses the text
;Inputs:   x=d2,y=d3
;Outputs:  None

Chg_Text:
	clr.l d0
	clr.l d1
	Move.w #9,d0
Chg_Text_Loop1:
	Move.w #54,d1
Chg_Text_Loop2:
	move.w d0,d4
	add.w d3,d4
	move.w d4,-(a7)
	move.w d1,d4
	add.w d2,d4
	move.w d4,-(a7)
	jsr util::pixel_chg
	add.l #4,a7
	dbra.b d1,Chg_Text_Loop2
	dbra.b d0,Chg_Text_Loop1
	rts

;******************************************
;Discription: Puts a border around the screen
;Inputs:   None
;Outputs:  None

Border:	
	Lines #0,#0,#239,#0
	Lines #0,#1,#239,#1
	Lines #0,#2,#239,#2	
	Lines #0,#0,#0,#127
	Lines #1,#0,#1,#127	
	Lines #2,#0,#2,#127		
	Lines #239,#0,#239,#127
	Lines #238,#0,#238,#127
	Lines #237,#0,#237,#127
	Lines #0,#127,#239,#127
	Lines #0,#126,#239,#126
	Lines #0,#125,#239,#125
	rts

;******************************************
;Discription: displays the title screen
;Inputs:   None
;Outputs:  None

Title_Screen: 
	jsr util::zap_screen	
	bsr Border
	StrWrite #40,#10,Nibbelz,#1,#2
	StrWrite #110,#30,HighScore,#1,#1
	StrWrite #10,#42,VEasy,#1,#1
	StrWrite #10,#52,Easy,#1,#1
	StrWrite #10,#62,Medium,#1,#1
	StrWrite #10,#72,Hard,#1,#1
	StrWrite #10,#82,VHard,#1,#1
	StrWrite #74,#100,Name,#1,#1
	StrWrite #50,#110,EMail,#1,#1
	bsr Save_Screen
	move.w #10,d2
	move.b Selection,d3
	add.w #41,d3
	move.w #70,d5
	move.w #40,d6
	bsr Chg_Text
	bsr PutScores
	bsr All_Keys_Up
Title_Screen_LBL1:
	cmp.b #0,Selection
	beq Title_Screen_Down
	getkey #0,#5
	bne Title_Screen_Down
	sub.b #10,Selection
	clr.l d3
	move.b Selection,d3
	add.w #41,d3
	bsr Put_Screen
	bsr Chg_Text
	bsr PutScores
	bsr All_Keys_Up
Title_Screen_Down:
	cmp.b #40,Selection
	beq Title_Screen_Enter
	getkey #0,#7
	bne Title_Screen_Enter
	add.b #10,Selection
	clr.l d3
	move.b Selection,d3
	add.w #41,d3
	bsr Put_Screen
	bsr Chg_Text
	bsr PutScores
	bsr All_Keys_Up	
Title_Screen_Enter:
	getkey #6,#6
	beq End_Title_Screen
	getkey #9,#1
	beq End_Title_Screen
	getkey #8,#6
	bne Title_Screen_LBL1
	move.b #1,SnakeDied
End_Title_Screen:
	rts

;******************************************
;Discription: Loads a level
;Inputs:   a0
;Outputs:  None

Load_Level:   
	clr.l d0
	clr.l d2
	clr.l d1
	move.b #0,d2
Load_Level_Loop1:
	mulu.b #4,d2
	add.l d2,a0
	move.l (a0),d0
	sub.l d2,a0
	clr.l d1
	move.b #0,d1
Load_Level_Loop2:
	clr.l d4
	move.b #31,d4
	sub.b d1,d4
	btst.l d4,d0
	beq Load_Level_Lbl1
	add.b #1,d1
	add.b #4,d2
	mulu.b #4,d1
	divu.b #2,d2
	add.b #2,d2
	putblock d1,d2
	sub.b #2,d2
	mulu.b #2,d2
	divu.b #4,d1
	sub.b #1,d1
	sub.b #4,d2
Load_Level_Lbl1:
	add.b #1,d1
	cmp.b #32,d1
	blt Load_Level_Loop2
	divu.b #4,d2
	add.b #1,d2
	mulu.b #4,d2
	add.l d2,a0
	move.l (a0),d0
	sub.l d2,a0
	clr.l d1
	move.b #0,d1
Load_Level_Loop3:
	clr.l d4
	move.b #31,d4
	sub.b d1,d4
	btst.l d4,d0
	beq Load_Level_Lbl2
	add.b #33,d1
	mulu.b #4,d1
	divu.b #2,d2
	add.b #2,d2
	putblock d1,d2
	sub.b #2,d2
	mulu.b #2,d2
	divu.b #4,d1
	sub.b #33,d1
Load_Level_Lbl2:
	add.b #1,d1
	cmp.b #26,d1
	blt Load_Level_Loop3
	divu.b #4,d2
	add.b #1,d2
	cmp.b #56,d2
	blt Load_Level_Loop1
	rts

;******************************************
;Discription: displays the statics bar at the bottom of the screen
;Inputs:   None
;Outputs:  None

Do_Bottom:    
	lea LCD_MEM,a0
        add.l #3840,a0
	clr.l d0
	move.b #239,d0
Do_Bottom_Loop1:
	move.b #0,-(a0)
	dbra.b d0,Do_Bottom_Loop1
	sub.l #3600,a0
	
	clr.l d0
	lea AbbrevSettings(pc),a0
	move.b Selection,d0
	divu.b #10,d0
	mulu.b #3,d0
	add.l d0,a0
	move.l a0,-(a7)
	move.w Lifes(pc),-(a7) 
	move.w Level(pc),-(a7)
	move.w Score(pc),-(a7)
	move.w AppleNum(pc),-(a7)
	cmp.b #1,GameWasBeat
	bne Do_Bottom_Lbl1
	pea Format
	bra Do_Bottom_Lbl2
Do_Bottom_Lbl1:
	pea Format2
Do_Bottom_Lbl2:
	pea Buffer
	jsr doorsos::sprintf
	add.l #20,a7
	StrWrite #1,#122,Buffer,#1,#0
	rts

;******************************************
;Discription: Changes the level
;Inputs:   None
;Outputs:  None

Switch_Level: 
	move.b #5,Direction
	move.b #5,Direction2
	move.w #0,AppleNum
	jsr util::zap_screen
	bsr Border
	cmp.w #1,Level
	move.w Level,-(a7)
	pea DispLevel
	pea Buffer
	jsr doorsos::sprintf
	add.l #10,a7
	StrWrite #87,#40,Buffer,#1,#2
	move.w #95,d2
	move.w #55,d3
	bsr Skill_Level
	move.w Score,-(a7)
	pea DispScore
	pea Buffer
	jsr doorsos::sprintf
	add.l #10,a7
	StrWrite #84,#70,Buffer,#1,#1
	bsr Wait_Key
	lea Lvl1(pc),a0
	bsr Which_Level
	jsr util::zap_screen
	Lines #0,#0,#239,#0
	Lines #0,#1,#239,#1
	Lines #0,#2,#239,#2	
	Lines #0,#0,#0,#119 
	Lines #1,#0,#1,#119	
	Lines #2,#0,#2,#119		
	Lines #239,#0,#239,#119
	Lines #238,#0,#238,#119
	Lines #237,#0,#237,#119
	Lines #0,#119,#239,#119
	Lines #0,#118,#239,#118
	Lines #0,#117,#239,#117 
	bsr Load_Level
	bsr Apples
	lea snake_x(PC),a0
	lea snake_y(PC),a1
	move.b #2,(a0)
	move.b #2,(a1)
	move.b #2,1(a0)
	move.b #2,1(a1)
	move.b #2,2(a0)
	move.b #2,2(a1)
	move.b #2,Snake_Lenght
	move.b #5,Direction
	bsr Snake
	bsr Do_Bottom
	bsr All_Keys_Up
	bsr Any_Keys_Down
	rts

;******************************************
;Discription: Displays the score
;Inputs:   a0,d4,d3
;Outputs:  None

WriteScore: 
	movem.l d0-d7/a0-a6,-(a7)
	move.w  #1,-(a7)
	jsr	doorsos::FontSetSys
	add	#2,a7
	move.w	#1,-(a7)
	move.l	a0,-(a7)
	move.w	d4,-(a7)
	move.w	d3,-(a7)
	jsr	doorsos::DrawStrXY
	add	#10,a7
	movem.l (a7)+,d0-d7/a0-a6
	rts

;******************************************
;Discription: Writes the word for the skill setting
;Inputs:   d2,d3
;Outputs:  None
	
Skill_Level:  
	cmp.b #0,Selection
	bne Skill_LevelLbl1
	StrWrite d2,d3,VEasy,#1,#1
Skill_LevelLbl1:
	cmp.b #10,Selection
	bne Skill_LevelLbl2
	StrWrite d2,d3,Easy,#1,#1
Skill_LevelLbl2:
	cmp.b #20,Selection
	bne Skill_LevelLbl3
	StrWrite d2,d3,Medium,#1,#1
Skill_LevelLbl3:
	cmp.b #30,Selection
	bne Skill_LevelLbl4
	StrWrite d2,d3,Hard,#1,#1
Skill_LevelLbl4:
	cmp.b #40,Selection
	bne Skill_LevelLbl5
	StrWrite d2,d3,VHard,#1,#1
Skill_LevelLbl5:
	rts

;******************************************
;Discription: Displays the score screen, not part of the title screen
;Inputs:   None
;Outputs:  None   

ShowScores:
	jsr util::zap_screen
	bsr Border
	StrWrite #90,#10,HighScore,#1,#1
	move.w #90,d2
	move.w #20,d3
	bsr Skill_Level
	clr.l d0
	clr.l d1
	move.w Score,-(a7)
	pea YourScore
	pea Buffer
	jsr doorsos::sprintf
	add.l #10,a7
	StrWrite #50,#105,Buffer,#1,#1
	move.w #50,d5
	move.w #45,d6
	bsr PutScores
	rts

;******************************************
;Discription: Displays the high scores
;Inputs:   d6,d5
;Outputs:  None

PutScores:    
	movem.l d0-d7,-(a7)
	clr.l d0
	clr.l d1
	move.w d6,d4
	move.w d5,d3
	lea Nibbelzcores(pc),a0
	move.l #120,d0
	move.b Selection,d1
	divu.b #10,d1
	mulu.l d1,d0
	add.l d0,a0
	clr.l d2
	move.b #4,d2
PutScoresLbl1:
	bsr WriteScore
	add.l #22,a0
	pusha
	move.w (a0),d5
	move.w d5,-(a7)
	pea Scoresformat
	pea Buffer
	jsr doorsos::sprintf
	add.l #10,a7
	add.w #130,d3
	StrWrite d3,d4,Buffer,#1,#1
	sub.w #130,d3
	popa
	add.l #2,a0
	add.w #11,d4
	dbra.b d2,PutScoresLbl1
	movem.l (a7)+,d0-d7
	rts

;******************************************
;Discription: Gets the new high score
;Inputs:   None
;Outputs:  None

SetHighScore: 
	lea Nibbelzcores,a0
	move.l #120,d0
	clr.l d1
	move.b Selection,d1
	divu.b #10,d1
	mulu.l d1,d0
	add.l #22,d0
	add.l d0,a0
	clr.l d2
	move.b #4,d2
SetHighScoreLoop1:
	move.w (a0),d0
	cmp.w Score,d0
	ble SetHighScoreLbl2
	add.l #24,a0
	dbra.b d2,SetHighScoreLoop1
	bra SetHighScoreLbl3
SetHighScoreLbl2:
	lea Nibbelzcores,a0
	move.l #120,d0
	clr.l d1
	move.b Selection,d1
	divu.b #10,d1
	mulu.l d1,d0
	add.l #94,d0
	add.l d0,a0
	clr.l d1
	cmp.w d1,d2
	beq SetHighScoreLbl4
SetHighScoreLoop2:
	clr.l d0
	move.w #11,d0
SetHighScoreLoop3:
	move.w (a0),24(a0)
	sub.l #2,a0
	dbra.w d0,SetHighScoreLoop3
	add.w #1,d1
	cmp.w d1,d2
	bgt SetHighScoreLoop2
SetHighScoreLbl4:
	add.l #2,a0
	jsr util::zap_screen
	bsr Border
	StrWrite #60,#10,congratulation,#1,#2
	StrWrite #50,#23,HScoreMsg,#1,#1
	StrWrite #4,#43,Entername,#1,#1
	Input #40,#43,#1,#1,#21
	add.l #22,a0
	move.w Score,(a0)
SetHighScoreLbl3:
	rts

;******************************************working**************************************

;******************************************Main*****************************************

_main:
	jsr cprgmsw::init_prgm
	jsr cprgmsw::init_getkey
	lea snake_x(PC),a0
	lea snake_y(PC),a1
      	move.b #2,(a0)+
	move.b #2,(a1)+
	move.b #2,(a0)+
	move.b #2,(a1)+
	move.b #2,(a0)+
	move.b #2,(a1)+
Main2:
	move.b #0,apple_y
	move.b #0,apple_x
	move.b #0,SnakeDied
	move.b #0,Snake_Lenght
	move.b #5,Direction
	move.b #5,Direction2
	move.b #0,Snake_Lenght
	move.w #1,Level
	move.w #1,Score
	move.b #0,GameWasBeat
	move.b #0,InfiniteLifes
	bsr Title_Screen
	cmp.b #1,SnakeDied
	beq EndGame2
	
	cmp.b #0,Selection
	bne mainLbl1
	move.l #35,Snake_Delay
	move.w #7,Lifes 
mainLbl1:
	cmp.b #10,Selection
	bne mainLbl2
	move.l #20,Snake_Delay
	move.w #5,Lifes
mainLbl2:
	cmp.b #20,Selection
	bne mainLbl3
	move.l #16,Snake_Delay
	move.w #5,Lifes
mainLbl3:
	cmp.b #30,Selection
	bne mainLbl4
	move.l #11,Snake_Delay
	move.w #5,Lifes
mainLbl4:
	cmp.b #40,Selection
	bne mainLbl5
	move.l #6,Snake_Delay
	move.w #3,Lifes
mainLbl5:
	bsr Switch_Level
mainLoop1:
	delay #$3Eb
	getkey #0,#4
	bne Testup
	move.b #1,Direction2
	bra End_Key_Test
Testup:
	getkey #0,#5
	bne Testright
	move.b #3,Direction2
	bra End_Key_Test
Testright:
	getkey #0,#6 
	bne Testdown
	move.b #2,Direction2
	bra End_Key_Test
Testdown:
	getkey #0,#7
	bne TestPlus
	move.b #4,Direction2
	bra End_Key_Test
TestPlus:
	getkey #8,#4
	bne TestApps
	move.b #1,GameWasBeat
	cmp.w #Max_Levels,Level
	beq GameWon
	add.w #1,Level
	bsr Switch_Level
TestApps:
	getkey #7,#6
	bne Testesc
	bsr Save_Screen
	StrWrite #90,#55,Paused,#4,#2
	bsr All_Keys_Up
	bsr Any_Keys_Down
TestOn:
	getkey #0,#0
	beq DoOn
	getkey #0,#1
	beq DoOn
	getkey #0,#2
	beq DoOn
	bra TestExit
DoOn:
	jsr cprgmsw::deinit_getkey
	jsr cprgmsw::deinit_prgm
	trap #4
	jsr cprgmsw::init_prgm
	jsr cprgmsw::init_getkey
TestExit:
	getkey #0,#4
	beq ExitTestOn
	getkey #0,#5
	beq ExitTestOn
	getkey #0,#6 
	beq ExitTestOn
	getkey #0,#7
	beq ExitTestOn
	getkey #7,#6
	beq ExitTestOn
	bra TestOn
ExitTestOn:
	bsr Put_Screen
	bsr All_Keys_Up
	bsr Any_Keys_Down
Testesc:	
	getkey #8,#6
	beq EndGame
TestT:	getkey #4,#3
	bne TestI
	clr.l d0
	clr.l d1
	move.b apple_x,d0
	move.b apple_y,d1
	move.l #AppleSprite,a0
	jsr graphlib::put_sprite
TestI:	cmp.b #1,InfiniteLifes
	beq End_Key_Test
	getkey #7,#3
	bne End_Key_Test
	move.b #1,GameWasBeat
	move.b #1,InfiniteLifes
	bsr Do_Bottom
End_Key_Test:
	move.l DelayNum,d0
	cmp.l Snake_Delay,d0
	blt MainLbl7
	move.l #0,DelayNum
	bsr movesnake
		
	cmp.b #2,Direction
	beq Dirup
	cmp.b #1,Direction2		
	bne Dirup
	move.b #1,Direction
	bra End_Key_Test
Dirup:
	cmp.b #4,Direction
	beq Dirright
	cmp.b #3,Direction2		
	bne Dirright
	move.b #3,Direction
	bra End_Key_Test
Dirright:
	cmp.b #1,Direction
	beq Dirdown
	cmp.b #2,Direction2		
	bne Dirdown
	move.b #2,Direction
	bra End_Key_Test
Dirdown:
	cmp.b #3,Direction
	beq MainLbl7
	cmp.b #4,Direction2		
	bne MainLbl7
	move.b #4,Direction
MainLbl7:
	add.l #1,DelayNum
 	cmp.b #1,SnakeDied
	bne MainLbl6
	cmp.b #1,InfiniteLifes
	beq SkipLifeTest
	cmp.w #0,Lifes
	beq EndGame
SkipLifeTest:
	sub.w #1,Lifes
	move.b #0,SnakeDied
	bsr Switch_Level
MainLbl6:
	cmp.w #10,AppleNum
	bne mainLoop1
	cmp.b #Max_Levels,Level
	beq GameWon
	add.w #73,Score
	cmp.b #0,Lifes
	ble SkipAddScore
	move.w Lifes(pc),d0
	mulu.w #31,d0
	add.w d0,Score
SkipAddScore:
	add.w #1,Level
	bsr Switch_Level
	bra mainLoop1
GameWon:
	cmp.b #1,GameWasBeat
	beq Next_Level
	bsr SetHighScore
	bsr ShowScores
	move.b #1,GameWasBeat
	bsr Wait_Key
Next_Level:
	move.w #1,Level
	bsr Switch_Level
	bra mainLoop1
EndGame:
	cmp.b #1,GameWasBeat
	beq MainLbl8
	bsr SetHighScore
MainLbl8:
	bsr ShowScores
	bsr Wait_Key
	bra Main2
EndGame2:
	bsr All_Keys_Up
	jsr cprgmsw::deinit_getkey	
	jsr cprgmsw::deinit_prgm
	rts

;******************************************Defines**************************************

Snake_Delay dc.l 0
DelayNum dc.l 0

AppleNum dc.w 0
Level dc.w 0	
Score dc.w 0
Lifes dc.w 0

Nibbelzcores:	dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0

		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0

		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0

		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0

		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0
		dc.b "...                  ",0,0,0

AbbrevSettings:	dc.b "VE",0
		dc.b "E ",0
		dc.b "M ",0
		dc.b "H ",0
		dc.b "VH",0
apple_y: dc.b 0
apple_x: dc.b 0
SnakeDied dc.b 0
Snake_Lenght dc.b 3
Direction dc.b 0
Direction2 dc.b 0
Selection dc.b 20
snake_x ds.b 251 ;Snake can be 50 units long in X (Need 1 extra space)
snake_y ds.b 251 ;Snake can be 50 units long in Y (Need 1 extra space)
LevelStr1 dc.b "Level1",0
LevelStr2 dc.b "Level2",0
Nibbelz dc.b "Nibbelz 92+ (v0.8",129,")",0
VEasy dc.b "Very Easy",0
Easy dc.b "  Easy   ",0
Medium dc.b " Medium  ",0
Hard dc.b "  Hard   ",0
VHard dc.b "Very Hard ",0
Name dc.b "By: Keith Neuse",0
EMail dc.b "E-Mail: CPrgmSwR2@AOL.COM",0
Paused dc.b "Paused",0
Format dc.b " Apples: %d     Score: %d     Level: %d     Lives: %d   %s   Nibbelz v0.8B ",190,0
Format2 dc.b " Apples: %d     Score: %d     Level: %d     Lives: %d   %s   Nibbelz v0.8B",0
DispLevel dc.b "Level: %d",0
YourScore dc.b "Most recent score: %d",0
HighScore dc.b "HighScore",0
Scoresformat dc.b "%d",0
Buffer ds.b 80
GameWasBeat dc.b 0
InfiniteLifes: dc.b 0
DispScore dc.b "Score: %05d",0
congratulation dc.b "Congratulation!",0
HScoreMsg dc.b "You've got a high score",0
Entername dc.b "Name:",0

;******************************************Sprites**************************************

blank1:		dc.w 4
		dc.w 1
		dc.b %00000000
		dc.b %00000000
		dc.b %00000000
		dc.b %00000000
		dc.b %11110000
		dc.b %11110000
		dc.b %11110000
		dc.b %11110000
AppleSprite:	dc.w 4
		dc.w 1
		dc.b %01100000
		dc.b %11110000
		dc.b %11110000
		dc.b %01100000
		dc.b %00000000
		dc.b %00000000
		dc.b %00000000
		dc.b %00000000 
AppleSprite2:	dc.w 4
		dc.w 1
		dc.b %10100000
		dc.b %01010000
		dc.b %10100000
		dc.b %01010000
		dc.b %11110000
		dc.b %11110000
		dc.b %11110000
		dc.b %11110000 

	END
